## Namespace widget

> Procedures for generating and processing metadata form widgets, editing attribute widgets

### Method Summary

Listing of public methods:

> widget::param_element_create

### Method Detail

* indicates required

Public Methods:

widget::param_element_create
Dipatches subprocs to generate the form elements for setting an attribute widget param Parameters:
`form` * | Name of the form in which to generate the form elements
`param` * | Name of the form widget param for which to generate a form element
`order` * | The order that the param form widget will appear in the form
`param_id` * | The ID of the form widget param
`default` * | The default value of the form widget param
`is_required` * | Flag indicating whether the form widget param is optional or required
`param_source` * | The default source of the value of the form widget param. One of literal, eval, query

Private Methods:

widget::create_options_param by Michael Pih
Create the options param form widget for adding/editing metadata form widgets Parameters:
`form` * | The name of the form
`order` * | The order of placement of the form widget within the form
`default` * | The default value of the form widget param value
`is_required` * | A flag indicating whether the form widget param value is mandatory
`param_source` * | The default param source for the form widget param value (literal, query, eval)

widget::create_param_source by Michael Pih
Create default param_source form widget for adding/editing metadata form widgets Parameters:
`form` * |
`order` * | The order of placement of the form widget within the form
`param_source` * | The default param source of the metadata widget (literal, query, eval)

widget::create_param_type by Michael Pih
Create default param_type form widget for adding/editing metadata form widgets Parameters:
`form` * | The name of the form
`order` * | The order of placement of the form widget within the form

widget::create_param_value by Michael Pih
Create default param_value form widget for adding/editing metadata form widgets Parameters:
`form` * | The name of the form
`order` * | The order of placement of the form widget within the form
`is_required` * | A flag indicating whether the value of the form widget param is mandatory

widget::create_text_param by Michael Pih
Create default text param form widget for adding/editing metadata form widgets Parameters:
`form` * | The name of the form
`default` * | The default value for the form widget param value
`is_required` * | A flag indicating whether the value of the form widget param is mandatory
`param_source` * | The deafult param source for the form widget param value (literal, query, eval)

widget::create_values_param by Michael Pih
Create the values param form widget for adding/editing metadata widgets Parameters:
`form` * | The name of the form
`order` * | The order of placement of the form widget within the metadata form
`default` * | The default value of the form widget param value
`is_required` * | A flag indicating whether the form widget param value is mandatory
`param_source` * | The default param_source for the form widget param value (literal, query, eval)

widget::process_param by Michael Pih
Edits a metadata form widget parameter from the form Parameters:
`db` * | A database handle
`form` * | The name of the form
`order` * | The order of placement of the param form widgets within the form
`content_type` * | The content type to which the attribute belongs
`attribute_name` * | The name of the attribute

* indicates required